\documentclass[a4paper,12pt,oneside]{scrreprt}
\usepackage[latin1]{inputenc}
\usepackage[T1]{fontenc}
\usepackage{ae,aecompl}
\usepackage[english]{babel}
\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsfonts}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage{wrapfig}
\usepackage{ulem}
\usepackage{cancel}
\usepackage{float}
\usepackage{color}
\usepackage{titlesec}
\usepackage{geometry}
\geometry{verbose,a4paper,tmargin=25mm,bmargin=25mm,lmargin=15mm,rmargin=25mm}
\titlelabel{\thetitle.\quad}
\usepackage{tabularx}
\usepackage{booktabs}
\usepackage{paralist}
\usepackage{textcomp}
\usepackage[official]{eurosym}

\renewcommand{\rmdefault}{phv}
\renewcommand{\sfdefault}{phv}

\begin{document}
    \begin{tabular*}{\textwidth}{c @{\extracolsep{\fill}} cc}
        \begin{large}
            \textbf{Prof. Lichter}
        \end{large} &

        \begin{minipage}[H]{3.5cm}
            \centering
            \begin{large}
                OOSC
            \end{large} \\
            \begin{large}
                WS 2019/2020
            \end{large}
        \end{minipage} &

        \begin{minipage}[H]{4cm}
            \includegraphics[keepaspectratio,width=\textwidth,angle=0]{logoswc.png}
        \end{minipage} \\
        Andreas Steffens & & \\
        Konrad F\"ogen & &  \\
        & \begin{huge}
              \textbf{Submission 1}
        \end{huge}&  \\
        & oosc@swc.rwth-aachen.de &  \\
        & & \\
        % Hier drunter mÃ¼ssen die Daten noch angepasst werden
        Issued: 21.10.2019 &
        Submission: 4.11.2019 &
        Discussion: 7.11.2019 \\
    \end{tabular*}
    \newline \newline \newline
    \begin{center}
        Submitted by 07

        \begin{tabular}{ll}
            Radu-Andrei Coanda, 344664. \\
            Clemens Frohnhofer, Matr.Nr. 333800\\
            Silas G\"unther, 382506  \\
            Christoph Kr\"amer, Matr.Nr. 318424  \\
            Felix Ingenerf, 355026. \\
        \end{tabular}
    \end{center}

    \setcounter{chapter}{1} % Aktuelles Assigment
    \section{Assignment: Reuse}
    To compute the \textbf{ROI} based on Pulin's Reuse Model we have first to extract the necessary information from the document. In the first part of the document the following values are stipulated. In the case of $Cost_{new}$ we have assumed that 100 \euro{} per LOC is what was meant.
    \begin{center}
        \begin{tabular}{ |c|c|c| }
            \hline
            \textbf{Description} & \textbf{Key}  & \textbf{Value} \\
            \hline
            \hline
            Cost of new code & $Cost_{new}$  & 100 \euro{}/LOC \\
            \hline
            Error rate & $error$ & 1.2 errors/KLOC \\
            \hline
            Cost of error & $Cost_{error}$ & 15000 \euro{}/error \\
            \hline
        \end{tabular}
    \end{center}

    The cost of reusing is said to be estimated 80\% lower than the cost of re-implementation. Therefore:
    \begin{align*}
        Cost_{reuse}    &= (1 - .8) \times Cost_{re-implementation} \\
        \implies RCR &= \frac{Cost_{reuse}}{Cost_{re-implementation}} = .2
    \end{align*}

    Together with the RCWR we can extend our table like follows:
    \begin{center}
        \begin{tabular}{ |c|c|c| }
            \hline
            \textbf{Description} & \textbf{Key}  & \textbf{Value} \\
            \hline
            \hline
            Relative cost of reuse & $RCR$  & .2 \\
            \hline
            Relative cost of writing for reuse & $RCWR$ & 1.7 \\
            \hline
        \end{tabular}
    \end{center}

    To compute the total amount of reused code we will sum up over all the projects the medical insurance system will be reused, while taking into consideration only the percentage of reused code for each application.

    \begin{align*}
        Code_{reused} &= .3 \times 50 + .5 \times 50 + .2 \times 50 + .1 \times 50\\
        &= (.3 + .5 + .2 + .1) \times 50 \\
        &= 55 \,KLOC
    \end{align*}

    Together with the code needed to make the current component reusable we extend our table in the following way:
    \begin{center}
        \begin{tabular}{ |c|c|c| }
            \hline
            \textbf{Description} & \textbf{Key}  & \textbf{Value} \\
            \hline
            \hline
            Reused code & $Code_{reused}$  & 55 KLOC \\
            \hline
            Code needed for reuse & $Code_{new}$ & 4 KLOC \\
            \hline
        \end{tabular}
    \end{center}

    Now we can finally start with the computation and it goes as follows:
    \begin{enumerate}
        \item Development Cost Avoidance (DCA):
        \begin{align*}
            DCA &= 55 \, KLOC \times .8 \times 100 \euro{}/LOC \\
            &= 4400000
        \end{align*}
        \item Maintenance Cost Avoidance (MCA):
        \begin{align*}
            MCA &= 55 \, KLOC \times 1.2 \, error/KLOC \times 15000 \euro{}/error \\
            &= 990000
        \end{align*}
        \item Reuse Cost Avoidance (RCA):
        \begin{align*}
            RCA &= 4400000 + 990000 = 5390000
        \end{align*}
        \item Additional Development Cost (ADC):
        \begin{align*}
            ADC &= (1.7 - 1) \times 4 \, KLOC \times 100 \euro{}/LOC \\
            &= 280000
        \end{align*}
        \item Return on Inverstment (ROI):
        \begin{align*}
            ROI &= 5390000 - 280000 = 5110000 \euro{}
        \end{align*}
    \end{enumerate}

    With this in mind we would recommend to the upper managment to \textbf{reuse} the component.

    \section{Assignment: Design by Contract}
    \begin{enumerate}
        \item [a)]  See OOSCDate.java in package de.rwth.swc.group07
        \item [b)]  See OOSCDate\_robust.java in package de.rwth.swc.group07
        \item [c)]  See OOSCDateTest for general test cases. \\
        See OOSCDDate\_DbCTest for DbC specific test cases. Here violations in the method input result in a RequireViolation exception which will be checked by the tests.\\
        See OOSCDate\_robustTest for Defensive Programming specific test cases. For Defensive Programming not suitable inputs result in IllegalArgumentExceptions which will also be checked by the tests.\\
        \item [d)]  In our implementations Design by Contract is used to verify, that the input given by the user is suitable for the concrete method and that after execution there is a valid result. Likewise we use Defensive Programming to throw exceptions when the user input is not fitting, but in comparison to Design by Contract the result of the methods is not checked. Thus there are mostly commonalities between our implementations with Design by Contract and with Defensive Programming.
        \newline
        In contrast it is also possible to implement OOSCDate with Defensive Programming in the sense, that wrong inputs would result in a correction to the nearest possible correct value. For example if -2 is given as input to setDay, this would result in the day being set to 1, as this is the nearest valid day value to the given input. Implementing OOSCDate this way would result in more conflicts between Design by Contract and Defensive Programming.
    \end{enumerate}
    \section{Assignment: Design by Contract with Inheritance}
    \begin{enumerate}
    	\item [a)]  See OOSCDateTime.java in package de.rwth.swc.group07
    	\item [b)]  No. If the interface would be changed, either OOSCDate must also be changed or would be abstract. This is not intended and therefore the interface should not be changed. Another argument against the necessity of changing the interface is that the interface itself is not part of Design by Contract.
    	\item [c)]  See OOSCDateTimeTest for general test cases. \\
    	See OOSCDDateTime\_DbCTest for DbC specific test cases. Here violations in the method input result in a RequireViolation exception which will be checked by the tests.\\
    \end{enumerate}
    
\end{document}
